%% Author: Aldrin
%% Created: 9 Oct 2012
%% Description: Some property examples to test the addone server program
-module(addone_scenarios).

%%
%% Include files
%%

% REFERENCE: MC ERLANG
-define(debug,true).
-include("macros.hrl").
% /REFERENCE: MC ERLANG

-export([simple/0, maxEx/0, cleanup/0]).

simple() ->
	register(client, self()),
	main_mon:start({addone, start, [0]}, property1(), [addone, client]),
	timer:sleep(400),
	addone:request(4).

maxEx() ->
	register(client, self()),
	main_mon:start({addone, start, [1]}, property2(), [addone, client]),
	timer:sleep(400),
	addone:request(4),
	addone:request(4).

property1() ->
	% Prop: Never ask for a 4 and get a 4
	fun([AddoneServer, Client]) ->
		detectEr:m_nec_recv(AddoneServer, 
							{request, Client, 4}, 
							detectEr:m_nec_send(Client, 
												{result, 4}, 
												detectEr:m_fls()))
	end.
    
property2() ->
	% Prop: Never ask for a 4 and get a 6 but its ok to request a 4 and get a 5
	fun([AddoneServer, Client]) ->
		detectEr:m_max(x, 
					   detectEr:m_and(detectEr:m_nec_recv(AddoneServer, {request, Client, 4}, 
														  detectEr:m_nec_send(Client, {result,6}, 
																			  detectEr:m_fls())),
									  detectEr:m_nec_recv(AddoneServer, {request, Client, 4},
														  detectEr:m_nec_send(Client, {result,5}, 
																   		      detectEr:m_var(x)))))
	end.

	
cleanup() ->
	main_mon:stop(),
	addone:stop(),
	unregister(addone).

