%% @author Aldrin
%% @doc @todo Add description to detectEr.
-module(detectEr).

% REFERENCE: MC ERLANG
-define(debug,true).
-include("macros.hrl").
% /REFERENCE: MC ERLANG

%% ====================================================================
%% API functions
%% ====================================================================
-export([m_fls/0, m_nec_recv/3, m_nec_send/3, m_and/2, m_max/2, m_var/1]).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

m_fls() ->  
	fun (_Mappings) ->	?FAIL_MON ! fail end.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
m_nec_recv(Receiver, Message, Phi) ->
	fun (Mappings) ->
		 receive
			 {action, {recv, Receiver, Message}} -> Phi(Mappings);
			 {action, _} -> ok
		 end
	end. 

m_nec_send(To, Message, Phi) ->
	fun (Mappings) ->
		 receive
			 {action, {send, _SentFrom, To, Message}} -> Phi(Mappings);
			 {action, _} -> ok
		 end
	end.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
m_and(Phi1, Phi2) ->
	fun (Mappings) ->
		 A = spawn(fun () -> Phi1(Mappings) end),
		 B = spawn(fun () -> Phi2(Mappings) end),
		 fork(A, B)
	end.

fork(A, B) ->
	receive
		Msg ->
			A ! Msg,
			B ! Msg
	end,
	fork(A, B).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

m_max(Var, Phi) ->
	fun (Mappings) ->
		Phi([{Var, Phi} | Mappings])
	end.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

m_var(Var) ->
	fun(Mappings) ->
			Monitor = lookUp(Var, Mappings),
			Monitor(Mappings)
	end.

lookUp(Var, Mappings) ->
	case Mappings of
		[{Var, Monitor} | _Other] -> Monitor;
		[ _ | Tail] -> lookUp(Var, Tail);
		[] -> exit
	end.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%