Definitions.

D   = [0-9]
L   = [A-Za-z]
WS  = ([\000-\s]|\.|\n|\n\r|\r\n|\t)
Ops = (!|\?)
FALSE = (\*ff)
VAR = (A-Z) 
NEC_OPEN = (\*NECO)
NEC_END = (\*NECC)
%NEC_OPEN = (\[)
%NEC_END = (\])
MAX_START = (\*max\()
MAX_END = (\*maxe)
AND_OP = (\^)
CLOSE = (\))
%PROP = (PROPERTY)
ERLANG_TERMS = [A-Za-z0-9{}\+\-\[\]_'///\/",=()\000-\s]
%ACTION_SUBJ = (A-Za-z0-9\000-\s)
%ACTION_VALUE = (A-Za-z0-9{}\+\-\[\]_'///\/",=()\000-\s)

Rules.

%{PROP}								: 	{token, {property_start, TokenLine, TokenChars}}.
{FALSE}								:	{token, {false, TokenLine, TokenChars}}.
{MAX_START}							:	{token, {max_start, TokenLine, TokenChars}}.
{MAX_END}							:	{token, {max_end, TokenLine, TokenChars}}.
{AND_OP} 							: 	{token, {and_op, TokenLine, TokenChars}}.
{VAR}								:   {token, {var, TokenLine, strip(TokenChars)}}.
{CLOSE}								:	{token, {close, TokenLine, TokenChars}}.
{NEC_OPEN}							:	{token, {nec_start, TokenLine, list_to_atom(TokenChars)}}.
{NEC_END}							:	{token, {nec_end, TokenLine, list_to_atom(TokenChars)}}.
{Ops}								:	{token, {action_ops, TokenLine, strip(TokenChars)}}.
{ERLANG_TERMS}+						:	{token, {term, TokenLine, strip(TokenChars)}}.
{D}* 								: 	{token, {text, TokenLine, TokenChars}}.
{L}* 								: 	{token, {text, TokenLine, TokenChars}}.
{WS}+  								: 	skip_token.


Erlang code.

strip(TokenChars) ->
	string:strip(TokenChars, both).